
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_applicationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_applications = await db.job_applications.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        cover_letter: data.cover_letter
        ||
        null
            ,
            
        applied_at: data.applied_at
        ||
        null
            ,
            
        last_updated_at: data.last_updated_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_applications.setJob_listing( data.job_listing || null, {
            transaction,
        });
        
        await job_applications.setApplicant( data.applicant || null, {
            transaction,
        });
        
        await job_applications.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.job_applications.getTableName(),
                belongsToColumn: 'resume_files',
                belongsToId: job_applications.id,
            },
            data.resume_files,
            options,
        );
        

        return job_applications;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_applicationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                cover_letter: item.cover_letter
            ||
            null
            ,
            
                applied_at: item.applied_at
            ||
            null
            ,
            
                last_updated_at: item.last_updated_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_applications = await db.job_applications.bulkCreate(job_applicationsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < job_applications.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.job_applications.getTableName(),
                    belongsToColumn: 'resume_files',
                    belongsToId: job_applications[i].id,
                },
                data[i].resume_files,
                options,
            );
        }
        

        return job_applications;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const job_applications = await db.job_applications.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.cover_letter !== undefined) updatePayload.cover_letter = data.cover_letter;
        
        
        if (data.applied_at !== undefined) updatePayload.applied_at = data.applied_at;
        
        
        if (data.last_updated_at !== undefined) updatePayload.last_updated_at = data.last_updated_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_applications.update(updatePayload, {transaction});

        
        
        if (data.job_listing !== undefined) {
            await job_applications.setJob_listing(
              
              data.job_listing,
              
              { transaction }
            );
        }
        
        if (data.applicant !== undefined) {
            await job_applications.setApplicant(
              
              data.applicant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await job_applications.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.job_applications.getTableName(),
                belongsToColumn: 'resume_files',
                belongsToId: job_applications.id,
            },
            data.resume_files,
            options,
        );
        

        return job_applications;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_applications = await db.job_applications.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_applications) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_applications) {
                await record.destroy({transaction});
            }
        });


        return job_applications;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_applications = await db.job_applications.findByPk(id, options);

        await job_applications.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_applications.destroy({
            transaction
        });

        return job_applications;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_applications = await db.job_applications.findOne(
            { where },
            { transaction },
        );

        if (!job_applications) {
            return job_applications;
        }

        const output = job_applications.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.job_listing = await job_applications.getJob_listing({
            transaction
        });
        
        
        output.applicant = await job_applications.getApplicant({
            transaction
        });
        
        
        output.resume_files = await job_applications.getResume_files({
            transaction
        });
        
        
        output.organizations = await job_applications.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.job_listings,
        as: 'job_listing',
        
        where: filter.job_listing ? {
          [Op.or]: [
            { id: { [Op.in]: filter.job_listing.split('|').map(term => Utils.uuid(term)) } },
            {
              job_title: {
                [Op.or]: filter.job_listing.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'applicant',
        
        where: filter.applicant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.applicant.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.applicant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'resume_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.cover_letter) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_applications',
                        'cover_letter',
                        filter.cover_letter,
                    ),
                };
            }
            

            
            

            
            if (filter.applied_atRange) {
                const [start, end] = filter.applied_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    applied_at: {
                    ...where.applied_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    applied_at: {
                    ...where.applied_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_updated_atRange) {
                const [start, end] = filter.last_updated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_updated_at: {
                    ...where.last_updated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_updated_at: {
                    ...where.last_updated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_applications.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_applications',
                        'cover_letter',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_applications.findAll({
            attributes: [ 'id', 'cover_letter' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['cover_letter', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.cover_letter,
        }));
    }

    
};

